unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, zipDLLImport, jpeg, Buttons, filectrl, ComCtrls;

type
  TForm1 = class(TForm)
    fundo: TImage;
    abook: TNotebook;
    Image1: TImage;
    Label3: TLabel;
    edtDestDir: TEdit;
    Shape1: TShape;
    SpeedButton1: TSpeedButton;
    progBar: TProgressBar;
    Label6: TLabel;
    lblArq: TLabel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    btnCancelar: TSpeedButton;
    Label1: TLabel;
    SpeedButton7: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure fundoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure fundoMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure btnCancelarClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure lerZipDoResource;
    procedure instalar(destdir: string);
    procedure TransCriar;
  end;

var
  Form1: TForm1;
  mx, my: integer;
  appdir: string; //diretrio da aplicao

implementation

{$R *.DFM}
{$R arquivos.res}

//Retira o arquivo zip do executvel
procedure TForm1.lerZipDoResource;
var
str: TResourceStream;
begin
     //arquivo zip
     str:= TResourceStream.Create(hInstance, 'arquivos', RT_RCDATA);
     str.SaveToFile(appdir + '~arquivos.zip');
     str.free;

     //zip dll
     if not fileExists(appdir + ZIPDLL) then begin
          str:= TResourceStream.Create(hInstance, 'zipdll', RT_RCDATA);
          str.SaveToFile(appdir + ZIPDLL);
          str.free;
     end;
     zipInitDll;
end;

procedure TForm1.instalar(destdir: string);
var
arqs: TStringList;
i: integer;
str: TMemoryStream;
arq: string;
begin
     //o ltimo caracter do dir tem que ser a barra '\'
     if destdir[length(destdir)-1] <> '\' then
          destdir:= destdir + '\';

     //retirar o arquivo zip do executvel
     lerZipDoResource;

     //carregar zip
     zipCarregarArq(appdir + '~arquivos.zip');
     arqs:= TStringList.create;
     str:= TMemoryStream.create;

     //pegar o nome de todos os arquivos do zip
     arqs.Text:= zipdllListarArqs;
     progbar.Position:= 0;
     progbar.Max:= arqs.Count;

     //extrair arquivos
     for i:= 0 to arqs.Count -1 do begin
          //se for um diretrio (e no arquivo) pular
          if arqs[i][length(arqs[i])] = '\' then begin
               progbar.Position:= progbar.position + 1;
               continue;
          end;

          //arquivo final
          arq:= destDir + arqs[i];
          lblArq.Caption:= 'Arquivo ' + arqs[i];

          //fora a criao da rvore at o arquivo
          ForceDirectories(extractFilePath(arq));

          //ler para o stream, salvar e limpar stream
          zipLerParaStream(arqs[i], str);
          str.SaveToFile(arq);
          str.clear;

          //mostra o status para o usurio
          progbar.Position:= progbar.position + 1;
          application.ProcessMessages;
          if btnCancelar.Down then break;
     end;

     //limpar tudo
     str.free;
     arqs.free;
     zipdllFecharArq;

     //deletar o arquivo zip
     DeleteFile(appdir + '~arquivos.zip');
end;

//=== Cria o formulrio transparente ===========================================
procedure TForm1.TransCriar;
var
  MaskMap: TBitmap;
  LinRgn,SpRgn,WinRgn: HRGN;
  Lin,Col,Cor: integer;
  Sl: PByteArray;
  SpEsq,SpDir: integer;
begin
  fundo.Picture.Bitmap.PixelFormat:= pf32bit;
  BorderStyle:= bsNone;
  BorderIcons:= [];
  MaskMap:= TBitmap.Create;
  MaskMap.Width:= fundo.Width;
  MaskMap.Height:= fundo.Height;
  MaskMap.Assign(fundo.Picture.Bitmap);
  MaskMap.Mask(fundo.Canvas.Pixels[0, fundo.height -1]);
  MaskMap.Canvas.CopyMode:= cmDSTINVERT;
  MaskMap.Canvas.Draw(0,0,MaskMap);
  MaskMap.PixelFormat:= pf8Bit;
  MaskMap.Canvas.CopyMode:= cmSRCCOPY;
  Height:= fundo.Height;
  Width:= fundo.width;
  WinRgn:= CreateRectRgn(0,0,0,0);
  for Lin:= 0 to Height-1 do begin
    LinRgn:= CreateRectRgn(0,Lin,0,Lin);
    Sl:= MaskMap.scanline[Lin];
    SpEsq:= 0; //SpDir:= 0;
    repeat
      Col:= SpEsq;
      Cor:= Sl[Col];
      repeat
        Col:= Col + 1;
      until (Col >= Width) or (Cor <> Sl[Col]);
      SpDir:= Col - 1;
      if Cor <> 0 then begin
        SpRgn:= CreateRectRgn(SpEsq,Lin,SpDir+1,Lin+1);
        CombineRgn(LinRgn, LinRgn, SpRgn, RGN_OR);
        DeleteObject(SpRgn);
      end;
      SpEsq:= SpDir+1;
    until (SpEsq >= Width);
    CombineRgn(WinRgn, WinRgn, LinRgn, RGN_OR);
    DeleteObject(LinRgn);
  end;
  SetWindowRgn(Handle,WinRgn,True);
  MaskMap.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     TransCriar;
     abook.ActivePage:= 'principal';
     appdir:= ExtractFilePath(application.ExeName);
end;

procedure TForm1.fundoMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     mx:= x; my:= y;
end;

procedure TForm1.fundoMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
     if not (ssLeft in shift) then exit;
     left:= left + (x - mx);
     top:= top + (y - my);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
opts: TSelectDirOpts;
dir: string;
begin
     dir:= edtDestDir.Text;
     opts:= [sdAllowCreate, sdPerformCreate, sdPrompt];
     if not fileexists(dir) then dir:= '';
     if SelectDirectory(dir, opts, 0) then begin
          edtDestDir.Text:= dir;
     end;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
     application.Terminate;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
     abook.ActivePage:= 'destino';
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
     abook.ActivePage:= 'instalando';
     Application.ProcessMessages;
     instalar(edtDestDir.text);
     abook.ActivePage:= 'completo';
end;

procedure TForm1.btnCancelarClick(Sender: TObject);
begin
     abook.ActivePage:= 'principal';
end;

end.
